'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _card = require('antd/lib/card');

var _card2 = _interopRequireDefault(_card);

var _spin = require('antd/lib/spin');

var _spin2 = _interopRequireDefault(_spin);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

require('antd/lib/card/style/css');

require('antd/lib/spin/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var styles = {};


var ChartCard = function ChartCard(_ref) {
  var _ref$loading = _ref.loading,
      loading = _ref$loading === undefined ? false : _ref$loading,
      contentHeight = _ref.contentHeight,
      title = _ref.title,
      action = _ref.action,
      total = _ref.total,
      footer = _ref.footer,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, ['loading', 'contentHeight', 'title', 'action', 'total', 'footer', 'children']);

  var content = _react2.default.createElement(
    'div',
    { className: styles.chartCard },
    _react2.default.createElement(
      'div',
      { className: styles.meta },
      _react2.default.createElement(
        'span',
        { className: styles.title },
        title
      ),
      _react2.default.createElement(
        'span',
        { className: styles.action },
        action
      )
    ),

    // eslint-disable-next-line
    total && _react2.default.createElement('p', { className: styles.total, dangerouslySetInnerHTML: { __html: total } }),
    _react2.default.createElement(
      'div',
      { className: styles.content, style: { height: contentHeight || 'auto' } },
      _react2.default.createElement(
        'div',
        { className: contentHeight && styles.contentFixed },
        children
      )
    ),
    footer && _react2.default.createElement(
      'div',
      { className: styles.footer },
      footer
    )
  );

  return _react2.default.createElement(
    _card2.default,
    _extends({
      bodyStyle: { padding: '20px 24px 8px 24px' }
    }, rest),
    _react2.default.createElement(
      _spin2.default,
      { spinning: loading },
      content
    )
  );
};

exports.default = ChartCard;
module.exports = exports['default'];